SystemOrganization addCategory: 'OrbeonBPMXpdl'!

Object subclass: #BpmProcessGenerator
	instanceVariableNames: 'xpdlPools processes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl'!

!BpmProcessGenerator class methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 17:54'!
exampleGenerator

	^self on: (XPDLReader2 exampleMultipleProcesses) xpdlPools! !

!BpmProcessGenerator class methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 17:54'!
on: collectionOfXPDLPools

	^super new initialize
		xpdlPools: collectionOfXPDLPools;
		yourself! !

!BpmProcessGenerator methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:29'!
generateAllProcess

	xpdlPools do: [:each | | newProcess |
		newProcess := self generateProcessBasedOn: each.
		processes at: newProcess processName put: newProcess.
	].

	^processes! !

!BpmProcessGenerator methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:22'!
generateProcessBasedOn: aXPDLPool
	"The receiver creates BPM process definition <BpmProcessDefinition> based on the XPDL pool <aXPDLPool>"
	| processDefinition |

	processDefinition := BpmProcessDefinition newNamed: aXPDLPool getName.
	"it create the corresponding Bpm definition for each Xpdl artifact <xpdlActivity>"
	aXPDLPool activities do: [:xpdlActivity | (xpdlActivity createBpmDefinitionOn: processDefinition) addToParentProcess].

	aXPDLPool transitions collect: [:xpdlTransition | | newTransition |
		newTransition := (xpdlTransition createBpmDefinitionOn: processDefinition) addToParentProcess.
		newTransition setStartArtifact: (xpdlTransition startNode getArtifactFrom: processDefinition).
		newTransition setEndArtifact: (xpdlTransition endNode getArtifactFrom: processDefinition).
	].

	^processDefinition! !

!BpmProcessGenerator methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 14:51'!
initialize

	super initialize.

	processes := Dictionary new.! !

!BpmProcessGenerator methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 17:48'!
processes
	^processes! !

!BpmProcessGenerator methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 17:48'!
processes: newValue
	processes := newValue! !

!BpmProcessGenerator methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 17:54'!
xpdlPools
	^xpdlPools! !

!BpmProcessGenerator methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 17:54'!
xpdlPools: newValue
	xpdlPools := newValue! !
